package enseirb.myinpulse.service.database.old_controllers_to_convert_to_services;

import enseirb.myinpulse.model.Project;
import enseirb.myinpulse.repository.ProjectRepository;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

import java.time.LocalDate;
import java.util.Optional;

@RestController
public class ProjectController {

    @Autowired ProjectRepository projectRepository;

    @GetMapping("/Project")
    @ResponseBody
    public Iterable<Project> allProjects() {
        return this.projectRepository.findAll();
    }

    @GetMapping("/Project/{id}")
    public Project getProjectById(@PathVariable Long id) {
        Optional<Project> project = this.projectRepository.findById(id);
        if (project.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce projet n'existe pas");
        }
        return project.get();
    }

    @PostMapping("/Project")
    public Project addProject(@RequestBody Project project) {
        return this.projectRepository.save(project);
    }

    @PostMapping("/Project/{id}")
    public Project updateProject(
            @PathVariable Long id,
            String projectName,
            byte[] logo,
            LocalDate creationDate,
            String projectStatus) {
        Optional<Project> project = this.projectRepository.findById(id);
        if (project.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce projet n'existe pas");
        }
        if (projectName != null) {
            project.get().setProjectName(projectName);
        }
        if (logo != null) {
            project.get().setLogo(logo);
        }
        if (creationDate != null) {
            project.get().setCreationDate(creationDate);
        }
        if (projectStatus != null) {
            project.get().setProjectStatus(projectStatus);
        }
        return this.projectRepository.save(project.get());
    }
}
